 extern "C"
{
#include "fxlib.h"
#include "LibText.h"
#include "usefull.h"
#include "math.h"
}

#include "generateur.h"
#include "MonochromeLib.h"
#include "donjon.h"
#include "PNJ.h"
#include "ennemi.h"
#include "etreVivant.h"
#include "heros.h"

#define TAILLE_HEAP 500


/************************************

La classe PNJ: mere de l'ennemi et de l'allie.
Elle s'occupe principalement de l'IA

************************************/

unsigned char PNJ::allerVers(unsigned char* map, unsigned char tailleX,unsigned char tailleY,unsigned char pointXBase, unsigned char pointYBase, unsigned char pointXFin, unsigned char pointYFin)
{




}


unsigned int PNJ::IA(unsigned char* map,unsigned char tailleX,unsigned char tailleY,EtreVivant* etreVivant)
{
if(doitPasserTour){return IA_RIEN;doitPasserTour--;}

int caseX = positionX/16;
int caseY = positionY/16;
int differenceX = etreVivant[0].getX()-positionX;
int differenceY = etreVivant[0].getY()-positionY;
int distanceX = differenceX*differenceX;
int distanceY = differenceY*differenceY;
if(distanceX+distanceY >5*5*16*16)return 0;

if(distanceX+distanceY==256)
    {
    if(differenceX<0)return IA_ATK+GAUCHE;
    if(differenceX>0)return IA_ATK+DROITE;
    if(differenceY<0)return IA_ATK+HAUT;
    if(differenceY>0)return IA_ATK+BAS;
    }

if(differenceY<0 && (map[caseX+(caseY-1)*tailleX]&MASQUE_ID)!=MUR && !(map[caseX+(caseY-1)*tailleX]&MASQUE_ETRE_VIVANT))return IA_DEPLACEMENT+HAUT;
if(differenceY>0 && (map[caseX+(caseY+1)*tailleX]&MASQUE_ID)!=MUR && !(map[caseX+(caseY-1)*tailleX]&MASQUE_ETRE_VIVANT))return IA_DEPLACEMENT+BAS;
if(differenceX<0 && (map[caseX-1+(caseY)*tailleX]&MASQUE_ID)!=MUR && !(map[caseX+(caseY-1)*tailleX]&MASQUE_ETRE_VIVANT))return IA_DEPLACEMENT+GAUCHE;
if(differenceX>0 && (map[caseX+1+(caseY)*tailleX]&MASQUE_ID)!=MUR && !(map[caseX+(caseY-1)*tailleX]&MASQUE_ETRE_VIVANT))return IA_DEPLACEMENT+DROITE;
return 0;
}
