#ifndef _DEFINITION_H_
#define _DEFINITION_H_

//#define NO_IA_SLOWDOWN

#define ICON_DISTANCE_DIVI 100

#define SHIP_OVERHEAT_TIME_DIVI 2


#define IA_FOLLOW_MIN_TARGET_SPEED 128

#define IA_FOLLOW_CLOSE_DISTANCE 200

#define IA_FOLLOW_GO_SLOW_FACTOR 2

#define IA_FOLLOW_FASTER_THAN_FACTOR 1.1


#define MAX_GAIN 10000

#define MIN_GAIN 100

#define MAX_ESCAPE_SPEED 150

#define MAX_FOLLOW_SPEED 75

#define IA_SPAWN_CHANCE 5000

#define MAX_SPAWN_DISTANCE_X 500
#define MAX_SPAWN_DISTANCE_Y 500

#define MIN_SPAWN_DISTANCE_X 100
#define MIN_SPAWN_DISTANCE_Y 100

#define MAX_SPAWN_COUNT 3

#define MAX_SPAWN_GROUPE 4

#define MAX_STAR_POINT_HIDE 20

#define STAR_POINT_COUNT 10

#define STAR_POINT_DIVI 1

#define MAX_PRICE_DIFFERENCE 10

#define MAX_ITEM_TYPE 5

#define LOOP_STAR_POINT_TICK_DIVI 1

#define MAX_ITEM_PER_SHOP 5

#define MAX_SHIP_FUEL 500000

#define SHIP_FUEL_CONSOMATION 1

#define ASTEROID_RENDER_RAYON 5

#define MAX_SYSTEM_SLIDE 25

#define MIN_PLANET_DIST 10

#define MAX_PLANET_TRY 100

#define MAX_PLANET_RAYON 8

#define MIN_PLANET_RAYON 3

#define SYSTEM_DISTANCE 64

#define PLANET_ASTEROID_CHANCE 3

#define MAX_PLANET_IN_SECTOR 5

#define MAX_PLANET_TYPE 1

#define MAX_OBJECT_SECTOR 10

#define MAX_X_PLANET_SECTOR 1024
#define MAX_Y_PLANET_SECTOR 1024

#define MAX_X_SECTOR 8192
#define MAX_Y_SECTOR 8192

#define SIZE_X_SECTOR 1024
#define SIZE_Y_SECTOR 1024

#define MAX_SIZE_X_OBJECT 50
#define MAX_SIZE_Y_OBJECT 50

#define SLOWER_VALUE 2

#define IA_SPEED 20
#define PLAYER_SPEED 20

#define LASER_DAMAGE 5

#define ESCAPE_RANDOM_FACTOR 1
#define ESCAPE_RANDOM_TIME 90

#define MAX_SHIP_HEALTH 1000

#define CURSOR_SIZE 6

#define SHIP_COOLDOWN 50

#define MAX_SHIP_HEAT 10000

#define EXISTING_OBJECT_TYPE 2

#define MAX_SHIP 20

#define MAX_TARGET_UPDATE 120

#define IA_SHIP_DELETE_DISTANCE 2000

#include "lookup.h"

#define IA_START_ESCAPE_LEVEL 20

#define GAME_ALLOW_SPECTATE 0

//#define SignedMax(a) ((a < 0 ? ((int)a)-1 : ((int)a)+1 ))


class Object
{
    public:
    int posX;
    int posY;
    int sizeX;
    int sizeY;

    int sector;

    int type;
    int id;
    int texture;
    int rotation;
};

class planet
{
    public:
    int posX;


    int exist;
    int type;
    int rayon;
    int distanceRayon;

    int planetSeed;


    int haveAsteroid;
};

class item
{
    public:

    int type;
    int price;

};

    //public
        extern Object * sectorObject;
        extern int sectorObjectCount;

        extern int cameraX;
        extern int cameraY;

        extern int playerShipId;
        extern int saveSeed;

#endif
