#ifndef _SHIPTEXTURE_H_
#define _SHIPTEXTURE_H_

#include "definition.h"
#include "shipEngine.h"


    //public
        void ApplyForces(int * x, int * y, int * speedX, int * speedY);
        void TickPhysic();
        int CollisionShipPoint(int x, int y);
        int CollisionShipBox(int boxX, int boxY, int boxSizeX, int boxSizeY);
        int CollisionShipBoxEliminate(int boxX, int boxY, int boxSizeX, int boxSizeY, int eliminateId);
        int CollisionShipBoxTarget(int boxX, int boxY, int boxSizeX, int boxSizeY, int targetId);
        int CollisionBoxBox(int boxX, int boxY, int boxSizeX, int boxSizeY, int box2X, int box2Y, int boxSize2X, int boxSize2Y);
        int CollisionBoxPoint(int boxX, int boxY, int boxSizeX, int boxSizeY, int pointX, int pointY);
        int PointLineCollisionAlgorythm(int posX, int posY, int directionX, int directionY,int step, int maxLengh);
        int DirectionAngle(int posX, int posY, int directionX, int directionY);
        void DirectionToPoint(int direction,int * addX, int * addY);

        extern int playerX;
        extern int playerY;

    //private
        int GetShipSpeed(ship * currentShip);
        int CollisionPointWorld(int x, int y);



#endif // _SHIPTEXTURE_H_
