//BON


#include "weaponEngine.h"
#include "definition.h"
#include "physicEngine.h"
#include "calculator.h"
#include "shipEngine.h"
#include "ship.h"

#include <stdio.h>




void FireLaser(int posX, int posY, int direction, int sourceId) // attaque en ligne
{
    int baseX = posX;
    int baseY = posY;
    int loop = 0;
    int addX = 0;
    int addY = 0;
    int collide = 0;
    int type = shipList[sourceId].type;
    int laserLength = shipDefinition[type].laserLength;

    DirectionToPoint(direction,&addX,&addY);


    int boxX = addX<0 ? posX-laserLength : posX;
    int boxY = addY<0 ? posY-laserLength : posY;


    if(CollisionShipBoxEliminate(boxX,boxY,laserLength,laserLength,sourceId) == -1)
    {
        if(posX+laserLength < cameraX|| posY+laserLength < cameraY|| posX - laserLength > cameraX+127 || posY - laserLength > cameraY+63) return;
    }
    else
    {
        collide = 1;
    }

    ML_pixel(posX-cameraX,posY-cameraY,1);

    while(loop < laserLength)
    {

        if(collide)
        {
            int shipCollided = CollisionShipPoint(posX,posY);
            if(shipCollided != -1 && shipCollided != sourceId)
            {

                DamageShip(shipCollided,shipDefinition[type].laserDamage, sourceId);

                break; // touch !
            }
        }



        posX += addX;
        posY += addY;

        loop++;
    }
    ML_line(baseX-cameraX,baseY-cameraY,posX-cameraX,posY-cameraY,1);
}

