#include "string.h"
#include "donjon.h"


/************************************

Toutes les donnees du jeu sont concentrees ici.
Elles devraient normalement etre remplacees par des fichiers
Les sprites se trouvent dans le fichier graphismes

************************************/

/************************************

Toutes les donnees brutes
(effets, cout, etc.)

************************************/



unsigned short getEffetSort(unsigned char ID)
{
unsigned short effetSort[255] =
{
0x0C10,0x1010,0x00B0,0x0410,0x0130,0x0178,0x0230,0x1410,0x0018,0x0810,0x0012,0x0011,0x002C,0x0013,//sorts de CAC physique
0x3E30,0x2A30,0x2840,0x2D44,0x2EA0,0x3401,0x32F8,0x2650,0x2601,0x21FC,//sort degat magique du mage
0x3E13,
0x2053,
0x3050,
0x3673,
0x3940,
0x2233,
0x3F07
};
return effetSort[ID];
}





/*"tourbillon",//CAC physique
"coup double",
"coup risque",
"percage",
"coup dangereux",
"coup assomant",//5
"spouha",
"coup triple",
"frappe puissante",
"fauchage",
"frappe executive",//10
"coud'bouclier",
"retournement",
"shunpo",
"boule de feu",//sort degat magiques
"foudre",
"zone gelee",
"gifle de namzar",
"meteore",
"coup de vent",
"firewall",
"tremblement",
"tornade",
"porte divine",
"vol-vie",
"absorption",
"raz de sang",
"sangsues",
"piques sanguines",
"lance aspirante",
"recuperation"
*/unsigned char getCoutSort(unsigned char ID)
{
unsigned char cout[255]={0x42,0x22,0x31,0x13,0x31,0x32,0x62,0x52,0xAA,0x61,0x24,0x21,0x11,0x11,
0x11,0x22,0x14,0x22,0x55,0x11,0x13,0x22,0x11,0x61,
0x11,0x31,0x11,0x33,0x44,0x53,0x22};
return cout[ID];
}


unsigned char getAnimationSort(unsigned char ID)
{
return 1;
unsigned char animation[255]={1,2,3,4,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1};
return animation[ID];
}


void loadCaraEnnemi(unsigned char ID,unsigned char* cara)
{
unsigned char caracteristique[6][10] ={
{8 ,0,7 ,8 ,0,10,0,1 ,3 ,1},
{10,0,10,10,0,10,0,3 ,6 ,2},
{12,0,9 ,12,0,12,0,3 ,7 ,3},
{15,0,14,12,0,12,0,6 ,10,4},
{18,0,16,15,0,15,0,8 ,15,5},
{20,0,20,20,0,15,0,10,16,8}};

for(int i = 0;i<10;i++)cara[i] = caracteristique[ID][i];
}

/*


"tourbillon",//CAC physique
"coup double",
"coup risque",
"percage",
"coup dangereux",
"coup assomant",
"spouha",
"coup triple",
"frappe puissante",//8
"fauchage",
"frappe executive",
"coud'bouclier",
"retournement",
"shunpo",
"boule de feu",//sort degat magiques
"foudre",
"zone gelee",
"gifle de namzar",
"meteore",
"coup de vent",
"firewall",
"tremblement",
"tornade",
"porte divine",
"vol-vie",
"absorption",
"raz de sang",
"sangsues",
"piques sanguines",
"lance aspirante",
"recuperation"*/

int loadArbreCompetence(unsigned char lequel,unsigned char* sort,unsigned char* colonne,unsigned char* lien)
{
unsigned char nombre[NOMBRE_ARBRE]={7,7,9,7};
unsigned char sorts[NOMBRE_ARBRE][10]=
{
{1,2,3,4,7,6,0},
{5,8,9,10,11,12,13},
{14,15,16,17,18,19,20,21,23},
{24,25,26,27,28,29,30}
};
unsigned char colonnes[NOMBRE_ARBRE][10]=
{
{0,1,1,2,2,3,4},
{0,1,2,2,3,3,4},
{0,1,1,2,2,2,3,3,4},
{0,1,1,2,3,3,4},
};

unsigned char liens[NOMBRE_ARBRE][15]=
{
{7,0x01,0x02,0x13,0x24,0x35,0x45,0x56},
{7,0x01,0x12,0x13,0x24,0x35,0x46,0x56},
{12,0x01,0x02,0x13,0x14,0x24,0x25,0x36,0x46,0x47,0x57,0x68,0x78},
{8,0x01,0x02,0x13,0x23,0x34,0x35,0x46,0x56},
};

int i;
for(i =0;i<nombre[lequel];i++)
    {
    sort[i] = sorts[lequel][i];
    colonne[i] = colonnes[lequel][i];

    }
for(i =0;i<=liens[lequel][0];i++)lien[i]=liens[lequel][i];
return nombre[lequel];
}

/************************************

Toutes les donnees litteraires
(nom, descriptions, etc.)

************************************/


void getDialogueScenario(unsigned char ID,String* string)
{
char nom[9][1200]={
"Cela fait bientot 3 jours que je suis en route pour le petit village de soienf, qui avait lance un appel a l'aide. Meme si la quete n'est pas faite pour un aventurier de ma trempe, je n'ai plus eu de mission depuis un long moment, donc faute de grive, je mange des asticots. Apparemment, le village serait la cible de diverses attaques d'orc et d'autres creatures malefique... Mais bon, je ne devrai pas tarder a arriver, on verra bien de quoi il s'agit.",
"En arrivant au bout du donjon, j'apercois deux orcs en pleine discussion... En me cachant, je reussi a entendre un peu ce qu'il disent... Ils parlent de noche de walpurgis et de rituels sataniques?? ***BOUM*** Et m*rde, ma hache est tombee... Evidemment, les orcs s'enfuient en courant... Il ne sont pas connus pour etre courageux (et tant mieux ! :p), mais ils ont laisse derriere eux leur prisonnier evanoui... Je ferai bien de partir avec lui.",
"En arrivant dans le plus etage de la plus haute tour du donjon, j'apercois soudain une princ.. a non, c'est jeucazu4noobz en fait. \"Tiens donc, un aventurier... Que fait tu donc ici?\" \n\"Je viens te peter la tronche !\" \n\"Les aventuriers sont tellement subtils ^^ Tu desires donc m'empecher de prendre le controle du monde... Pourquoi tout le monde s'oppose tout le temps a mes plans malefiques? Mais si tu desires tant que ca m'affronter, cela devra attendre plus tard, car j'ai rendez-vous avec mes collegues malefique, mouahahaha\" \n*POUF* \nOh non ! Il a disparu dans un nuage de fumee digne de batman ! Le lache !... Bon je fais quoi maintenant? Il m'a coupe dans mon elan... Ben du coup, je vais rentrer en reprenant ce gars evanoui avec moi.",
"En arrivant au bout du chemin, j'apercois une masure de sorciere. En me disant que cela devait etre la maison de la sorciere, j'y fout le feu (la subtilite, c'est pour les tapette ! ). En fouillant les restes carbonises, je remarque que les potions sont plus des onguents de soin que des potions de destructionsf... Mais bon, cela n'aura surement aucune incidence sur la suite de mon aventure, hein?",
"En arrivant au bous du chemin, j'apercois un vieil homme de dos, ayant l'air de mediter. M'aprochant de lui, je le sort de sa meditation en lui plantant mon epee dans le dos. Vaut mieux pas prendre de risque avec les sorciers. En agonisant au sol, son regard a l'air de m'interroger, de me demander \"pourquoi?...\" \nJe m'eloigne rapidement, les corbeaux ne vont pas tarder a rappliquer, et je deteste ces bestioles",
"En arrivant au bout du donjon, je me retrouve sur une sorte de plateau de pierre, avec jeucazu4noobz en face de moi derriere un autel. \n\"Bienvenue, heros ! Ici tu vas pouvoir gouter a mon pouvoir et accomplir la prophetie de qwerty ! Il ne me manque qu'un peu de sang d'aventurier pour achever ma transformation et me permettre de dominer le monde ! Et en plus, comme tu as tue les sorciers protecteur de ce lieu, personne ne peut plus m'arreter ! \nMouhahahahaha !\" \n\"dois-je en comprendre que le villageois etait avec toi depuis le debut ?\" \n\"tout juste auguste ! Pour sauver sa miserable vie, il etait pres a tout ! Tu te sens trahis, n'est-il pas?\" \n\"Ben pas tant que ca en fait... Je veux dire, c'etait quand meme assez previsible, le coup",
" de la trahison et de la manipulation du heros... Faudrait changer de plan un de ces jours...\" \n\"Euh... Peu importe ! Tu vas mourir ici et maintenant !\" \n\"Tu penses bien que si ton plan etait si previsible, j'ai pris quelques precautions avant... \n*sort un instrument* \nPFOUI CLING CLING YEAH YEAH CLING *joue tres mal de la musique* *C'est super efficace !*\" \n\"Arg ! Mais comment?? Tu etais cense etre un aventurier debutant, facile a tuer et qui ne se renseigne pas sur ses ennemis ! Je ne comprend point !\" \n\"Et bien sache que l'on t'as mal renseigne ! Je suis celui qui a tue jeucazu1noobz !\" \nDis-je, en tranchant sa tete.",
" \n \n \n \nFin \n \n \nVoila, c'est la fin de ce jeu ! Comme vous avez pu le voir, c'est encore une demo, il manque plein de sorts, d'armes, d'elements, etc., mais cela viendra peut etre ! En tout cas, si une suite voit le jour, tout le scenario sera explique ! Car oui, ce qui est arrive est logique si on suit le scenario que j'ai fait, mais je n'en dis pas plus :p \nEn tout cas encore un grand merci, et bon anniversaire planete-casio ;) (je rapelle que ce jeu a ete fait pour les dix ans de planete-casio, mais c'est deja note dans les credits ^^ ) \nTiens d'ailleurs comme tu as fini le jeu, tu peux choisir la classe \"heros\" ! C'est pas trop-style ca?" 
};
string->add(nom[ID]);
if(ID == 6){string->add(nom[ID+1]);string->add(nom[ID+2]);}
}

void getDialogue(unsigned char ID,String* string)
{
char nom[10][550]=
    {
    "Heros! Heros! C'est une catastrophe! Tous les habitants ont ete capture! Le malefique jeucazu4noobz est certainement derriere ca! J'ai trouve des traces d'orc en direction de la foret profonde, peut-etre devrait tu commencer par la...",
    "Tu dis qu'ils parlait de la noche de walpurgis? Il s'agit d'une nuit ou les pouvoirs magiques sont decuples... Quelques soit son plan, nous devons l'en empecher. Tu devrais aller voir comment va roger le tavernier.",
    "Merci de m'avoir sauve des griffes de ces monstres mon petit ! Sans toi je ne serai que des nutriments dans le ventre d'un orc. De ce que j'ai compris, jeucazu4noobz a enferme les villageois dans la tour malefique, et compte leur faire un rituel bizarre... Sauve les, je t'en prie !",
    "Ainsi, il veut dominer le monde? Comme c'est original... Neanmoins, avec les informations que tu as recoltee, il nous sera possible de contrecarrer ses plans... Il faut commencer par eliminer ses complices, il me semble qu'une sorciere puissante se cache dans le chemin de la sorciere...",
    "Salut ! Tu veux faire un gros dodo pour soigner ton bras casse et tes nombreuses blessures mortelles? Ce sera 4 PO la nuit :)", 
    "Merci de m'avoir sauve ! Tiens, comme cadeau je te vends des armes pas chere ! Comment ca ? Non, je ne peux te les donner pour te remercier et pour t'aider a sauver le monde, capitaliste un jour, capitaliste toujours !",
    "tu veux des armes? Tu peux en acheter ici !",
    "Bravo ! Je pense qu'il ne reste qu'un sorcier dans la ronde des sorciers, et puis jeucazu4noobz sera le seul sorcier a 1000 km a la ronde ! Bonne chance heros !",
    "Vite heros, c'est le moment de frapper! Il ne reste que quelques heure avant la noche de walpurgis ! Tu dois affronter jeucazu4noobz, il doit certainement se terrer dans son QG, dans les falaises sanglantes ! Bonne chance, le destin du monde repose sur tes epaules !",
    "Pitie ! Pitie ! Je ne voulais pas ! C'est lui qui m'a force, je le jure ! Pitie, epargne moi heros ! \n \n\"Tu ne merite pas que j'emousse ma lame pour te tuer\" \n \nOh... Merci..."
    };
if(ID == 0xFF)string->add("vous voila regenere apres une bonne nuit de sommeil !");
else string->add(nom[ID]);

}

void getNomEnnemi(unsigned char ID,String* string)
{
char nom[16][16]=
{
"orc",
"lapicorne",
"chovsoris",
"bouldepoil",
"saqdeneu",
"dragon",
"kangokill",
"tornadus",
"patatou",
"limassif",
"tortublinde",
"aejesif",
"marteleur",
"ours",
"yeti",
"taupignax",
};
string->add(nom[ID]);

}


void getDescriptionArbre(unsigned char ID,String* string)
{
char description[NOMBRE_ARBRE][200]=
{
"Des degats de zone, de la brutalite, du sang et de la biere... Voila un arbre d'homme, de vrai !",
"C'est bien joli de faire des degats, mais il faut aussi survivre... Donc ici c'est bien :D",
"La force brute est la defense des faibles. Une bonne boule de feu est bien plus efficace !",
"Quels degats peuvent bien faire les ennemis, si ils n'arrivent pas a traverser mon bouclier de sang?"
};
string->add(description[ID]);

}






/*""zone gelee",
"gifle de namzar",
"meteore",
"coup de vent",
"firewall",
"tremblement",
"tornade",
"porte divine",*/
void getDescriptionSort(unsigned char ID,String* string)
{
char description[NOMBRE_SORT][65]=
{
"inflige [A] en cercle autour de vous",
"inflige [A] a deux ennemis proche",
"inflige 2[A] mais augmente les degats subit au tour suivant",
"inflige [A] jusqu'a 3 case en ligne devant vous",
"inflige 2[A] mais subit un contrecoups de [A]",
"inflige [A], peut assomme l'ennemi mais fait passer le tour",//5
"inflige 2[A] et [A] de contrecoups si tue",
"inflige [A] a trois ennemis proche",
"inflige 2[A] et [A] de contrecoups",
"inflige [A] aux 3 cases juste devant vous",
"inflige [A] et rejoue si tue l'ennemi",//10
"inflige [A] et /2 les degats subit au prochain tour",
"inflige [A] a l'ennemi situe derriere",
"se teleporte derriere l'ennmi et lui inflige [A](non-implemente)",
"inflige quelques degats a un ennemi devant",
"inflige quelques degats a un ennemi devant et a ses voisins",
"inflige quelques degats dans un carre 5*5 autour de vous",
"inflige de gros degats a un ennemi a une case de distance",
"inflige des degats dans un carre de 3*3 a une case de distance",
"repousse les ennemis (non-implemente)",
"inflige des degats dans une ligne a deux cases de distance",
"inflige des degats dans un carre 3*3 autour de vous",
"repousse les ennemis (non-implemente)",
"inflige d'enorme degats a l'ennemi devant vous",
"aspire quelques pv a un ennemi devant",
"aspire des pv a l'ennemi devant vous",
"inflige des degats en cone devant et a vous",
"aspire des pv autour de vous",
"inflige de gros degats autour et a vous",
"aspire des pv a tous les ennemis devant",
"aspire beaucoup de pv a un ennemi devant"
};
string->add(description[ID]);

}

void getNomArbre(unsigned char ID,String* string)
{
char nom[NOMBRE_ARBRE][20]=
{
"guerrier",
"paladin",
"mage",
"sorcier"
};
string->add(nom[ID]);
}

unsigned char* getNomSort(unsigned char ID)
{
unsigned char nom[NOMBRE_SORT][20]=
{
"tourbillon",//CAC physique
"coup double",
"coup risque",
"percage",
"coup dangereux",
"coup assomant",//5
"spouha",
"coup triple",
"frappe puissante",
"fauchage",
"frappe executive",//10
"coud'bouclier",
"retournement",
"shunpo",
"boule de feu",//sort degat magiques
"foudre",
"zone gelee",
"gifle de namzar",
"meteore",
"coup de vent",
"firewall",
"tremblement",
"tornade",
"porte divine",
"vol-vie",
"absorption",
"raz de sang",
"sangsues",
"piques sanguines",
"lance aspirante",
"recuperation"
};
return nom[ID];
}



void getDescriptionObjet(unsigned char ID,unsigned char* precision,String& string)
{
unsigned char description[NOMBRE_OBJET][100]=
{
"De l'argent ! Mon... PRECIEUX !",
"Une petite potion faite de... on sait pas trop",
"Une dose un peu plus grande que la petite",
"3 litres de potion, a boire cul sec !",
"Du concentre de magie pure. A comme un gout de pomme",
"Au cas ou la dose normale ne suffit pas...",
"Mais comment une bouteille aussi grande rentre dans le sac? O_o",
"Une epee courte, mais quand meme moins que ***SBAF***",
"Ni courte ni longue, voici la moyenne !",
"Alors comme ca tu aimes quand c'est long?",
"Un sabre tout con. Oui je sais, on dirait une epee, mais c'est bien un sabre",
"Mais comment tu veux tuer des gens avec ca?",
"Une epee parfaite pour demarrer une grande aventure. Pour les enfant de 7 ans aussi.",
"Une epee se repaissant du sang de ses victimes. Ca sonnait moins gore dans ma tete",
"Une petite lame ayant appartenu a une grande dame.",
"Il faut la tenir bien ferme, et a deux mains ! (comme ma ***SBAF***)",
"Une epee lance flamme, pour gentillement cicatriser celui qui vient de prendre un coup",
"Ouaip. Cette lame mange les ames de vos victimes. C'est t-y pas hyper badass?",
"Une lame ayant appartenu a un roi givre",
"Une lame legendaire, ayant soi-disant defonce plein de dragon",
"Tranchante comme un rasoir",
"Mais pourqoui se battre avec une cle?? En plus elle devrait etre plus efficace comme marteau...",
"*inserer clin d'oeuil a un manga*",
"Fait de vous l'heritier du trone d'angleterre, dommage que vous n'ayez pas le papier le prouvant.",
"Une epee dont peu croyent en son existance. Un tare aurait reussi a la retrouver cependant.",
"Un Grand Pas pour l'homme, mais surtout pour cette epee ! (comprenne qui pourra)",
"Un choix tres barbare !",
"Dechire les ombres pour voir la verite dans ces destinees croisee",
};
if(ID == 255){string+="la poche principale de votre sac";return;}

if(precision[0] == POTION)
    {
    string+="potion de soin de ";
    if(precision[2] == SOIN_PV)string+="PV";
    else string+="PM";
    string+=" de ";
    string+=precision[3];
    string+=" %";
    }
else if(precision[0] == ARGENT)
    {
    string+="Sert a acheter diverses choses, et a dormir a l'auberge";
    }
else if(precision[0]==EPEE)
    {
    string+="arme pour niveau ";
    string+=precision[1];
    string+=" et + \ndegats : ";
    string+=precision[3];
    string+="-";
    string+=precision[4];
    if(precision[2] == D_BOUCLIER)
        {
        string+=" \nconvertis ";
        string+=precision[5];
        string+=" % en bouclier";
        }
    if(precision[2] == D_MAGIQUE)
        {
        string+=" \ndegat magiques : ";
        string+=precision[5]*precision[3]/100;
        string+="-";
        string+=precision[5]*precision[4]/100;
        }
    if(precision[2] == D_EXECUTION)
        {
        string+=" \nsi tue, convertis ";
        string+=precision[5];
        string+=" % en bouclier";
        }
    }
string+=" \n \n";
string+=description[ID];
}

void getPrecisionObjet(unsigned char ID,unsigned char* precision)
{
unsigned char precisions[NOMBRE_OBJET][6]=
{
{ARGENT},
{POTION,0,SOIN_PV,10},
{POTION,0,SOIN_PV,25},
{POTION,0,SOIN_PV,50},
{POTION,0,SOIN_PM,10},
{POTION,0,SOIN_PM,25},
{POTION,0,SOIN_PM,50},
{EPEE,0,D_DEGAT,4,6},
{EPEE,3,D_DEGAT,8,11},
{EPEE,8,D_DEGAT,15,17},
{EPEE,2,D_DEGAT,5,7},
{EPEE,4,D_DEGAT,9,11},
{EPEE,0,D_DEGAT,4,8},
{EPEE,3,D_BOUCLIER,7,9,20},
{EPEE,7,D_DEGAT,14,17},
{EPEE,10,D_DEGAT,18,20},
{EPEE,5,D_MAGIQUE,8,10,50},
{EPEE,8,D_EXECUTION,14,18,100},
{EPEE,8,D_MAGIQUE,8,10,150},
{EPEE,0,D_DEGAT,6,8},
{EPEE,3,D_MAGIQUE,8,10,50},
{EPEE,6,D_DEGAT,14,16},
{EPEE,0,D_EXECUTION,5,7,50},
{EPEE,8,D_DEGAT,17,21},
{EPEE,4,D_MAGIQUE,7,9,100},
{EPEE,10,D_DEGAT,20,23},
{EPEE,7,D_EXECUTION,15,20,100},
{EPEE,9,D_MAGIQUE,10,12,250},
};
for(int i = 0;i<6;i++)precision[i] = precisions[ID][i];

}

void getNomObjet(unsigned char ID,String* string)
{
char nom[NOMBRE_OBJET][50]={
"argent",
"petite potion",
"potion moyenne",
"grande potion",
"petit elixir",
"elixir moyen",
"grand elixir",
"epee courte",
"epee moyenne",
"epee longue",
"sabre",
"fleuret",
"epee kokiri",
"buveuse de sang",
"Aiguille",
"epee a deux main",
"tranche-flamme",
"absorb'ame",
"Glace",
"falchion",
"la trancheuse",
"keyblade",
"zanpakto",
"excalibur",
"sourcelame",
"anduril",
"epee runique +8 qui boit les ames",
"dechireuse des ombres",
};
if(ID == 255)string->add("--Sac Principal--");
else string->add(nom[ID]);
}


int  getCoutObjet(int ID)
{
unsigned char cout[NOMBRE_OBJET]=
{
0,1,2,4,1,2,4,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95,100,105,110
};
return cout[ID];

}

void getNomLieux(unsigned char ID,String* string)
{
char nom[NOMBRE_LIEUX][25]={

"Foret profonde",
"Tour malefique",
"Chemin de la sorciere",
"Ronde des sorciers",
"Falaises sanglantes",
"gorges de l'infini"
};

string->add(nom[ID]);
}

