#ifndef HEROS_H
#define HEROS_H

#define TAILLE_INVENTAIRE 100
#include "objet.h"

class Heros:public EtreVivant
{

public :

    void init();
    int getCDV();
    void refreshCara();
    void afficherHUD(int X,int Y,int tailleX,int tailleY,unsigned char* argument);
	void victoireEnnemi(EtreVivant* ennemi);
    int lancerSort(unsigned char lequel,EtreVivant** etrevivant,int nombreEtreVivant);
    void afficherEcranPersonnage();
    void gererInventaire(unsigned char& menuX,unsigned char& menuY,bool& ok,int& menuScrolling,int& menuScrolling2);
    void ramasser(Objet* objet);
    void optimiserInventaire();
    void utiliserObjet(int objet);
    void nouvelEtage(unsigned char* map,unsigned char tailleX,unsigned char tailleY,unsigned char ville);
    int getXPCompetence();
    int recevoirXPCompetence();
    int getPourcentageXPCompetence();
    int getXPCompetenceNextLevel(int lequel);
    int getLevelCompetence();
    int getPointCompetence();
    void apprendreSort(int lequel);
    bool connaitSort(unsigned char lequel);
    int getXPSuivant();
    void memoire(Sauvegarde& sauvegarde);
    void finDonjon();
    void effetArme(EtreVivant* ennemi);
    void choixRace(int choix);
    void nuitAuberge(int cout);
    int payer(int cout);
    void recevoirObjet(int ID);

private :

    unsigned char inventaire[TAILLE_INVENTAIRE];
    unsigned char tailleInventaire;
    unsigned char precisionInventaire[TAILLE_INVENTAIRE];
    int caracteristiquesBase[7];
    int scrollingInventaire;
    unsigned char sortConnu[50];
    int choixObjet;
    int quete;

    int pointCompetence;
    int levelCompetence;
    int XPCompetence;
    unsigned char armeEquipee;

    int argent;
};

#endif
