extern "C"
{
#include "fxlib.h"
#include "LibText.h"
#include "usefull.h"
#include "math.h"
#include "string.h"
}
#include "options.h"
#include "string.h"
#include "MonochromeLib.h"


/************************************

Classe remplacant les strings absentes du sdk :'(

************************************/

String::~String()
{
if(sizeMax)delete[] stockage;
size = 0;
sizeMax = 0;
}



 char* inttostring(int nombre, char* str )
{
int i, length=0;
 str[0] = '0';
if(nombre)
    {
    if(nombre<0)
        {
        length++;
        str[0] = '-';
        nombre = -nombre;
        }
    for(i=nombre ; i ; i/=10) length++;
    str[length] = 0;
    for( ; nombre ; nombre/=10) str[--length] = nombre%10+'0';
    }
return str;
}


void String::afficher(int X,int Y,int mode)
{

if(!mode)Txt_Text(getStr(),X,Y,Options::getFont(),TXT_OR);
else Txt_Text(getStr(),X,Y,Options::getFont(),TXT_ON);
}


String::String(int nombre)
{

size = 0;
sizeMax = 0;
 char str[12] = {0};
inttostring(nombre,str);
add(str);
}

String::String(unsigned char* str)
{
size = 0;
sizeMax = 0;
add((char*)str);
}

String::String(char* str)
{
size = 0;
sizeMax = 0;
add(( char*)str);
}


char* String::getStr()
{
return (char*)stockage;
}


unsigned char* String::getStrU()
{
return (unsigned char*)stockage;
}

void String::operator+=(unsigned char* str)
{
add(( char*)str);
}

void String::operator+=(char* str)
{
add(( char*)str);
}


void String::operator+=(unsigned char nombre)
{
 char str[5] = {0};
inttostring((int)nombre,str);
add(( char*)str);
}

void String::operator+=(int nombre)
{
 char str[12] = {0};
inttostring(nombre,str);
add(( char*)str);
}


void memcpyT(char* dest,char* source,int byte)
{
for(int i = 0;i<byte;i++)dest[i]=source[i];
dest[byte]=0;

}




void String::add(char* str)
{
int i = 0;
int taille = mesurer(str);
if(!taille)return;
char* temp = 0;
if(!size)
    {
    sizeMax = 20+taille;
    stockage = new char[sizeMax];
    }
else if(taille+size+5>sizeMax)
    {
    sizeMax =size+taille+10;
    temp = new char[sizeMax];
    memcpyT(temp,stockage,size);
    delete[] stockage;
    stockage = temp;
    }
for(;str[i];i++)stockage[i+size]=str[i];
size+=i;
stockage[size]=0;

}


int String::mesurer(char* str)
{
for(int i = 0;;i++)if(!str[i])return i;
}




void String::afficherRetour(int x,int y)
{
char vide[50]={0};
char temp[50]={0};
int start = 0;
for(int i=1;stockage[i-1]!=0 && i<sizeMax;i++)
    {
    if(stockage[i] == '\n' || !stockage[i])
        {
        memcpyT(temp,vide,50);
        memcpyT (temp,(char*)&stockage[start],i-start);
        start = i+1;
        Txt_Text(temp,x,y,Options::getFont(),TXT_OR);
        y+=Options::getHauteurFont()+1;
        }
    }

}

void String::afficherScrolling(int x,int y,int maxX,int moment)
{
moment = moment%((size*(Options::getLargeurFont()+1))+30);

moment-=6;
if(moment<0)moment = 0;
int decalage = moment%(Options::getLargeurFont()+1);
moment/=(Options::getLargeurFont()+1);

if(!Options::getDouxScrolling())decalage =0;
char temp[50]={0};
int taille = (maxX+Options::getLargeurFont()-x)/(Options::getLargeurFont()+1);
maxX = x+taille*(Options::getLargeurFont()+1);
bool tropGrand=0;
if((size-moment)>=taille)tropGrand=1;


if(size<taille)
    {
    decalage = 0;
    memcpyT(temp,stockage,taille);
    }
else if(tropGrand)
    {
    if(decalage)taille++;
    memcpyT(temp,&stockage[moment],taille);
    if(!moment && !decalage)for(int i = 1;i<3;i++)temp[taille-i]='.';
    }
else
    {
    memcpyT(temp,&stockage[size-taille+1],taille);
    decalage=0;
    }
Txt_Text(temp,x-decalage,y,Options::getFont(),TXT_OR);
ML_rectangle(x-Options::getLargeurFont(),y-1,x-1,y+Options::getHauteurFont(),0,ML_WHITE,ML_WHITE);
ML_rectangle(maxX,y-1,maxX+Options::getLargeurFont(),y+Options::getHauteurFont(),0,ML_WHITE,ML_WHITE);
}



int String::afficherDialogue(int moment)
{

char vide[50]={0};
char temp[50]={0};
int start = 0;
int i=1;
int largeurFont = Options::getLargeurFont()+1;
int hauteurFont = Options::getHauteurFont()+1;
int Xactuel = 5;
int y = 39;

while(stockage[start] && start<=moment)
    {
    if(stockage[start] == '\n')
        {
        start++;
        Xactuel=5;
        y+=hauteurFont;

        }
    for(i = 1;stockage[start+i] != ' ' && stockage[start+i] != '\n';i++)if(!stockage[start+i])break;
    
    if(Xactuel+i*(largeurFont) >=124)
        {
        Xactuel=5;
        y+=hauteurFont;
        if(y>60-hauteurFont)
            {
            if(moment-Options::getVitesse()-1<start && moment>=start)return 0;
            y = 39;
            ML_rectangle(5,39,123,59,0,ML_WHITE,ML_WHITE);
            }
        start++;
        i--;
        }

    memcpyT(temp,vide,50);
    memcpyT (temp,(char*)&stockage[start],min(i,moment-start));
    Txt_Text(temp,Xactuel,y,Options::getFont(),TXT_ON);
    Xactuel+=i*(largeurFont);
	start+=i;
    }
if(stockage[moment])return 1;
return 2;
}


void String::afficherWordWrap(int x,int y,int maxX)
{
char vide[50]={0};
char temp[50]={0};
int start = 0;
int i=1;
int largeurFont = Options::getLargeurFont()+1;
int hauteurFont = Options::getHauteurFont()+1;
int Xactuel = x;
while(stockage[start])
    {
    for(i = 1;stockage[start+i] != ' ' && stockage[start+i] != '\n';i++)if(!stockage[start+i])break;
    if(Xactuel+i*(largeurFont) >=maxX || stockage[start] == '\n')
        {
        Xactuel=x;
        y+=hauteurFont;
        start++;
        i--;
        }

    memcpyT(temp,vide,50);
    memcpyT (temp,(char*)&stockage[start],i);
    Txt_Text(temp,Xactuel,y,Options::getFont(),TXT_OR);
    Xactuel+=i*(largeurFont);
	start+=i;
    }
}


void String::afficherMenuDeroulant(int x,int y,int Xmax,int Ymax,int curseurY,int moment,int nombreElement,int titre,int afficherFleche)
{

int nombreLigne = (Ymax-y)/(Options::getHauteurFont()+1);
int camera = 0;
int largeur = Options::getLargeurFont()+1;
int hauteur = Options::getHauteurFont()+1;

if(curseurY>nombreLigne/2)camera = curseurY-nombreLigne/2;
if(camera+nombreLigne >nombreElement)camera =nombreElement-nombreLigne;
String fleche("\001");
char vide[50]={0};
char temp[50]={0};
int start = 0;
int end = 1;

for(int i=0;i<nombreLigne+camera && i<nombreElement;i++)
    {
    while(stockage[end]!='\n' && stockage[end])end++;
    if(i>=camera && i<nombreLigne+camera)
        {
        memcpyT(temp,&stockage[start],end-start);
        String affichage(temp);
        if(i == curseurY)
            {
            affichage.afficherScrolling(x+largeur*afficherFleche,y,Xmax,moment);
            if(afficherFleche)fleche.afficher(x,y);
            }
        else affichage.afficherScrolling(x+largeur*((!titre || i) && afficherFleche),y,Xmax,moment*titre*!i);
        y+=hauteur;
        }
    start = end+1;
    end++;
    }
}

int  String::afficherTexteDefilant(int x,int y,int Xmax,int Ymax,int moment)
{
moment-=30;
if(moment<0)moment = 0;
char vide[50]={0};
char temp[50]={0};
int start = 0;
int i=1;
int largeurFont = Options::getLargeurFont()+1;
int hauteurFont = Options::getHauteurFont()+1;
int Xactuel = x;
int Yactuel = y-moment+1;
while(stockage[start])
    {
    for(i = 1;stockage[start+i] != ' ' && stockage[start+i] != '\n';i++)if(!stockage[start+i])break;

    if(Xactuel+i*(largeurFont) >=Xmax || stockage[start+i] == '\n')
        {
        Xactuel=x;
        Yactuel+=hauteurFont;
        start++;
        i--;
        }

    memcpyT(temp,vide,50);
    memcpyT(temp,(char*)&stockage[start + (stockage[start] == '\n')],i);
    //if(Yactuel+hauteurFont<Ymax)
        if(Yactuel>-6 && Yactuel<70)Txt_text_taille(temp,Xactuel,Yactuel,Options::getFont(),TXT_OR,y-Yactuel,-Yactuel+Ymax);
    //else Txt_Text(temp,Xactuel,Yactuel,Options::getFont(),TXT_OR);
    Xactuel+=i*(largeurFont);
	start+=i;
    }
if(Yactuel+hauteurFont>Ymax)return 1;
if(Yactuel<=Ymax)return 2;
return 0;
}


void String::afficherMilieu(int x,int y,int Xmax)
{

int Ttaille = size*(Options::getLargeurFont()+1);
afficher(((Xmax-x)-Ttaille)/2+x,y);
}

void String::afficherBoite(int x,int y,int Xmax,int Ymax,int moment,int tailleMax,int nombreElement)
{
afficherMenuDeroulant(x,y,Xmax,Ymax,moment/(tailleMax+5)/6,moment,nombreElement,0,0);
}



