#ifndef _RENDERENGINE_H_
#define _RENDERENGINE_H_

#include "definition.h"

    //public
        void RenderSector();
        void RenderAShip(int id,int x,int y,int rotation);
        void RenderShip();
        void DrawEmptyRectangle(int x1, int y1, int x2, int y2);
        void DrawSprite8bit(const unsigned char * image, int posX, int posY,int sizeX, int sizeY, int mirror);
        void SimpleRectangle(int x1, int y1, int x2, int y2, char fill_color);
        void TickStarPoint(int moveX, int moveY);
        void RenderStarPoint();
        int ResetStarPoint();

    //private
        class starPoint
        {
            public:
                int posX;
                int posY;
        };

#endif //_RENDERENGINE_H_
