#include "renderer.h"

#ifdef PC_INTERFACE
#include "calculator.h"
#include "worldGenerator.h"
#include <stdio.h>
#include <windows.h>
#include "shipTexture.h"
#include "shipEngine.h"
#include "physicEngine.h"
#else

#endif

#include <stdlib.h>

int test[10];
int testCounter = 0;


void RenderSector()
{

    for(int i = 0; i < 10 ; i++) test[i] = 0;
    testCounter = 0;

 //   printf("PRESENT : [");

    for(int i = 0 ; i < sectorObjectCount ; i++)
    {
        DrawEmptyRectangle(sectorObject[i].posX-cameraX,
                           sectorObject[i].posY-cameraY,
                           sectorObject[i].posX-cameraX+sectorObject[i].sizeX,
                           sectorObject[i].posY-cameraY+sectorObject[i].sizeY);
        /*
        printf("X%d Y%d donc X%d Y%d\n"
               ,sectorObject[i].posX
               ,sectorObject[i].posY
               ,sectorObject[i].posX-cameraX
               ,sectorObject[i].posY-cameraY);
        */

      //  if(sectorObject[i].sector < 0)
     //   {
         //   printf("Sector %d, %d/%d\n",sectorObject[i].sector,i,sectorObjectCount);


      //      if(sectorObject[i].sector == 0) printf("(%d;%d)\n",sectorObject[i].posX,sectorObject[i].posY);

            int found = 0;
            for(int x = 0 ; x < testCounter ; x++)
            {
                if(test[x] == sectorObject[i].sector) found = 1;
            }
            if(found == 0)
            {
                test[testCounter] = sectorObject[i].sector;
                testCounter++;
                printf("%d;",sectorObject[i].sector);
            }

      //      continue;
       // }


        if(sectorObject[i].posX-cameraX > 127 ||
           sectorObject[i].posY-cameraY > 64 ||
           sectorObject[i].posX-cameraX+sectorObject[i].sizeX < 0 ||
           sectorObject[i].posY-cameraY+sectorObject[i].sizeY < 0) continue;



    }

     //   printf("]\n");
   // DrawEmptyRectangle(0-cameraX+sectorX,0-cameraY+sectorY,SIZE_X_SECTOR-cameraX+sectorX,SIZE_Y_SECTOR-cameraY+sectorY);
}



void RenderShip(int id,int x,int y,int rotation8)
{

    if(x+20 < 0 || y+20 < 0 || x > 127 || y > 63) return;

    //rotation+=22;

   // if(rotation > 359) rotation -=360;
    if(rotation8 > 7) rotation8 -=8;

    //int rotation8 = (rotation*8/360);
    if(rotation8%2 == 0) // rotation sur 8 crans est pair donc image droite
    {
            DrawSprite8bit(shipNormal,x,y,19,19,rotation8/2);
    }
    else
    {
            DrawSprite8bit(shipRotated,x,y,19,19,(rotation8-1)/2);
    }

}
void RenderIA()
{
    for(int i = 0; i < shipCount ; i++)
        RenderShip(1+i,shipList[i].posX-cameraX,shipList[i].posY-cameraY,shipList[i].direction);
}

void DrawEmptyRectangle(int x1, int y1, int x2, int y2)
{
    ML_rectangle(x1+1,y1+1,x2-1,y2-1,0);
    ML_vertical_line(x2,y1,y2,1);
    ML_vertical_line(x1,y1,y2,1);
    ML_horizontal_line(y1,x1,x2,1);
    ML_horizontal_line(y2,x1,x2,1);
}

void DrawSprite8bit(const unsigned char * image, int posX, int posY,int sizeX, int sizeY, int mirror)
{
    if(mirror == 0)
    {
        for(int x = 0 ; x < sizeX ; x++)
        {
            for(int y = 0 ; y < sizeY ; y++)
            {
                if(image[x+y*sizeX] == 1)
                {
                    Bdisp_SetPoint_VRAM(x+posX,y+posY,1);
                }
                else if(image[x+y*sizeX] == 2)
                {
                    Bdisp_SetPoint_VRAM(x+posX,y+posY,0);
                }
            }
        }
    }

    if(mirror == 1)
    {
        for(int x = 0 ; x < sizeX ; x++)
        {
            for(int y = 0 ; y < sizeY ; y++)
            {
                if(image[x*sizeX+y] == 1)
                {
                    Bdisp_SetPoint_VRAM((sizeX-x-1)+posX,y+posY,1);
                }
                else if(image[x*sizeX+y] == 2)
                {
                    Bdisp_SetPoint_VRAM((sizeX-x-1)+posX,y+posY,0);
                }
            }
        }
    }
    if(mirror == 2)
    {
        for(int x = 0 ; x < sizeX ; x++)
        {
            for(int y = 0 ; y < sizeY ; y++)
            {
                if(image[x+y*sizeX] == 1)
                {
                    Bdisp_SetPoint_VRAM((sizeX-x-1)+posX,(sizeY-y-1)+posY,1);
                }
                else if(image[x+y*sizeX] == 2)
                {
                    Bdisp_SetPoint_VRAM((sizeX-x-1)+posX,(sizeY-y-1)+posY,0);
                }
            }
        }
    }
    if(mirror == 3)
    {
        for(int x = 0 ; x < sizeX ; x++)
        {
            for(int y = 0 ; y < sizeY ; y++)
            {
                if(image[x*sizeX+y] == 1)
                {
                    Bdisp_SetPoint_VRAM(x+posX,(sizeY-y-1)+posY,1);
                }
                else if(image[x*sizeX+y] == 2)
                {
                    Bdisp_SetPoint_VRAM(x+posX,(sizeY-y-1)+posY,0);
                }
            }
        }
    }
}
