#ifndef _WORLDENGINE_H_
#define _WORLDENGINE_H_

#include "definition.h"




    //private
        int intHash( int a);
        void TickSector(int posX, int posY);
        void LoadSector(int sectorId);
        void DeleteSector(int sectorId);
        int GenerateSectorObjectCount(int sectorId);
        int IsUsedZone(int x, int y, int sizeX, int sizeY, int sectorX, int sectorY);
        void GenerateObject(int sectorId);
        int IsSectorLoaded(int sectorId);

        extern int zoneSeed;
        extern Object * sectorObject;
        extern int sectorObjectCount;

    //public
        void TickSector(int x, int y);

        void GeneratePlanetSector(planet ** planetList,int * planetCount, int sectorX, int sectorY);
        void GetSystemSlide(int x,int y,int * slideX,int * slideY);

        extern int zoneSeed;

        extern int currentSector;
        extern int currentSectorList[4];

        void GenerateShopItemList(item ** itemList, int * itemCount, int shopKey);

        int GetSectorId(int x, int y);

        void ReloadAllSector();

#endif //_WORLDENGINE_H_
