#ifndef _WORLDGENERATOR_H_
#define _WORLDGENERATOR_H_

#include "definition.h"




    //private
        int intHash( int a);
        int IsSectorInScreen(int id);
        void TickSector(int posX, int posY);
        void LoadSector(int sectorId);
        void ClearSector(int sectorId);
        int GenerateSectorObjectCount(int sectorId);
        int IsUsedZone(int x, int y, int sizeX, int sizeY, int sectorX, int sectorY);;
        void GenerateObject(int sectorId);

        extern int seed;
        extern Object * sectorObject;
        extern int sectorObjectCount;

    //public
        void TickSector(int x, int y);

        extern int currentSector;
        extern int currentSectorList[4];

#endif
