extern "C"
{
#include "fxlib.h"
#include "LibText.h"
#include "usefull.h"
#include "stdlib.h"
#include "syscall.h"
}

#include "donjon.h"
#include "generateur.h"
#include "MonochromeLib.h"
#include "graphisme.h"
#include "string.h"
#include "log.h"
#include "options.h"
#include "sauvegarde.h"
#define REALEASE 0

/************************************

credits

************************************/


void loadPatternBrique(unsigned char* brique,int momentScrolling)
{
int chance = momentScrolling/30 +5;
for(int i = 0;i<160;i++)
    {
    if(random(100)<chance)brique[i] = 1;
    else brique[i] = 0;
    }
}

int quelleBrique(int X,int Y)
{
X/=2;
Y/=2;
return X+Y*5;
}


void credit()
{

if(!key_down(K_XT) && REALEASE)return;
int momentScrolling = 0;
int vaisseauY = 5;
int tirX[20]= {0};
int tirY[20] = {0};
int tirLance[20] = {0};
int aTire = 0;
int positionBriqueX= 130;
unsigned char brique[160] = {0};

int mort  = 0;
int finSauvee = 0;
int point = 0;
unsigned char explosion[7][8] = {{0,44,82,74,129,110,48,0},
{6,105,66,136,2,33,132,99},
{8,65,16,132,0,0,17,130},{0},{0},{0},{0}};


String text(" \n \n \n \n \nLes credits risquent d'etre tres long... Donc autant commencer tout de suite :p \n \n");
text+= "Le createur de ce jeu, c'est a dire moi, ben c'est Dodormeur, mais ca tu devais sans doute deja le savoir si tu as telecharge ce jeu depuis Planete-Casio :p \n \n";
text+= "En parlant de Planete-Casio, ce jeu a ete programme pour son concours 2014 pour ses 10 ans d'existance :D \n \n";
text+= "Bon, maintenant c'est le moment des remerciements. \nDonc je tiens a remercier toute la communaute de Planete-Casio, qui sont vraiment tres cool ;) \n \n";
text+= "Comme bibliotheques, j'utilise MonochromeLib de PierrotLL, ainsi que LibText de LePhenixNoir (mais quand meme pas mal modifiee par mes soins :p ) \n \n";
text+= "Bon, il me semble que c'est plus ou moins tout ce que je voulais dire en fait... Mais bon, pour garder le challenge de ce mini-jeu, je vais quand meme continuer a parler, juste comme ca \n \n";
text+="Il fait beau hein? \n... \nEn tout cas, a l'interieur de cette calculatrice, il fait beau :p \nEt tu deviens bon a ce jeu ! Encore un peu, et ton score deviendrai presque acceptable :D \n \n";
text+="Bon, une fois que tu en as marre de ce jeu, hesite pas a te laisser tuer pour en finir ^^ (non, ce n'est pas une apologie du suicide IRL :p ) \n \n";
text+="Arf, je pense que tu m'as battu :'( Pour te recompenser, tu as droit a la classe legendaire... J'ai nomme la classe guerrier de l'espace ! C'est-y pas beau tout ca?";
loadPatternBrique(brique,momentScrolling);

while(1)
    {
    if(!mort)point++;
    String score("score :");
    score+=point;
    positionBriqueX--;
    if(mort)mort++;
    if(mort > 100)return;

    if(key_down(K_MENU))return;

    if(positionBriqueX < -10)
        {
        loadPatternBrique(brique,point);
        positionBriqueX = 130;
        }
    if(!mort)
        {
        if(!key_down(K_EXE))aTire--;

        if(key_down(K_EXE) && aTire<1)
            {
            aTire = 5;
            for(int i = 0;i<20;i++)
                {
                if(tirLance[i] == 0)
                    {
                    tirX[i] = 6;
                    tirY[i] = vaisseauY+2;
                    tirLance[i] = 1;
                    break;
                    }
                }
            }
        if(key_down(K_UP))vaisseauY--;
        if(key_down(K_DOWN))vaisseauY++;
        if(vaisseauY<0)vaisseauY = 0;
        if(vaisseauY>59)vaisseauY = 59;
        }
    for(int i = 0;i<20;i++)
        {
        if(tirLance[i])
            {
            for(int j = 0;j<2 && tirLance[i];j++)
                {
                tirX[i]++;
                if(tirX[i]>130)tirLance[i]=0;
                if(tirX[i]>=positionBriqueX && tirX[i]<=positionBriqueX+10)
                    {
                    int caseMur = quelleBrique(tirX[i]-positionBriqueX,tirY[i]);
                    if(brique[caseMur])
                        {
                        brique[caseMur] = 0;
                        tirLance[i] = 0;
                        }
                    }
                }
            }
        }


    if(positionBriqueX <3 && positionBriqueX>-8)
        {
        int flag =0;
        int caseMur = quelleBrique(2-positionBriqueX,vaisseauY);
        if(brique[caseMur])flag = 1;
        caseMur = quelleBrique(2-positionBriqueX,vaisseauY+2);
        if(brique[caseMur])flag = 1;
        caseMur = quelleBrique(2-positionBriqueX,vaisseauY+4);
        if(brique[caseMur])flag = 1;
        if(flag)mort = 1;
        }

    if(text.afficherTexteDefilant(7,6,110,64,momentScrolling>>2) == 1)momentScrolling++;
    else if(!finSauvee && !mort){writeFile("shadow","cre",explosion[5],1);finSauvee = 1;}//on ne fait que toucher le fichier, ainsi on evite les gens qui modifient leur fichier de sauvegarde :p ce qui n'est pas plus securise, vu que tu es en train de lire ca ^^
    score.afficher(5,0);
    if(!mort)
        {
        ML_rectangle(0,vaisseauY,2,vaisseauY+4,0,ML_BLACK,ML_BLACK);
        ML_rectangle(2,vaisseauY+1,4,vaisseauY+3,0,ML_BLACK,ML_BLACK);
        ML_rectangle(4,vaisseauY+2,6,vaisseauY+2,0,ML_BLACK,ML_BLACK);
        }
    else ML_bmp_or(explosion[mort/15],0,vaisseauY,8,8);
    for(int i = 0;i<20;i++)if(tirLance[i])ML_line(tirX[i]-2,tirY[i],tirX[i],tirY[i],ML_BLACK);
    for(int i = 0;i<160;i++)if(brique[i])ML_point((i%5)*2+positionBriqueX,(i/5)*2,2,ML_BLACK);
    ML_display_vram();
    ML_clear_vram();
    setFps(4);

    }
}

/************************************

Main

************************************/

int menu()
{
int positionX = 0;
int positionY = 0;
int directionX = 0;
String choix1("nouveau jeu\ncontinuer\ncredit");
String choix2("partie 1\npartie 2\npartie 3");
String fleche("\001");
Donjon donjon;
int checkTouche = 0;
int frame = 0;
int fichier = 0;
int emplacementY = 40;
int choixContinuer;
const unsigned char ecran_titre[]={
0x0, 0x0, 0x0, 0x0, 0x1, 0xfc, 0x8, 0x8, 0xf, 0xe0, 0x3f, 0xf0, 0xf, 0xe0, 0x20, 0x82,
0x0, 0x0, 0x0, 0x0, 0x2, 0x2, 0x14, 0x14, 0x10, 0x10, 0x20, 0x8, 0x10, 0x10, 0x51, 0x45,
0x0, 0x0, 0x0, 0x0, 0x4, 0xfc, 0x15, 0xf4, 0x27, 0xc8, 0x2f, 0xe4, 0x27, 0xc8, 0x51, 0x45,
0x0, 0x0, 0x0, 0xf, 0xc9, 0x0, 0x17, 0xf4, 0x2f, 0xe8, 0x2f, 0xf4, 0x28, 0xeb, 0x51, 0x45,
0x0, 0x0, 0x0, 0x1f, 0xea, 0x0, 0x17, 0x16, 0x2c, 0x2e, 0x2c, 0x14, 0x28, 0xeb, 0xd1, 0x45,
0x0, 0x0, 0x0, 0x38, 0xb, 0x81, 0x97, 0x17, 0x2e, 0x2f, 0x2e, 0x16, 0x2c, 0x69, 0xd1, 0x45,
0x0, 0x0, 0x0, 0x38, 0xb, 0xc1, 0xd7, 0x97, 0xaf, 0x2b, 0xaf, 0x17, 0x2e, 0x28, 0xd1, 0x45,
0x0, 0x0, 0x0, 0x1c, 0xa, 0xe0, 0xf7, 0xf5, 0xef, 0xe9, 0xeb, 0x97, 0xaf, 0x2c, 0x51, 0x45,
0x0, 0x0, 0x0, 0xe, 0x9, 0xfc, 0x70, 0x7, 0xe0, 0x8, 0xe9, 0xd5, 0xeb, 0xae, 0x59, 0x45,
0x0, 0x0, 0x0, 0x7, 0xfc, 0x7, 0xf7, 0xf7, 0xef, 0xe8, 0x68, 0xf4, 0xe9, 0xef, 0x5d, 0x45,
0x0, 0x0, 0x0, 0x3, 0xff, 0xf3, 0xf4, 0x34, 0x28, 0x68, 0x28, 0x74, 0x68, 0xeb, 0xdf, 0x45,
0x0, 0x0, 0x0, 0x0, 0x3, 0x8a, 0x16, 0x14, 0x2c, 0x28, 0x2c, 0x34, 0x28, 0x69, 0xd7, 0x45,
0x24, 0x68, 0xa9, 0x23, 0x61, 0xcb, 0x17, 0x16, 0x2e, 0x2c, 0x2e, 0x14, 0x2c, 0x28, 0xd3, 0x45,
0x2a, 0x8c, 0x34, 0x54, 0x60, 0xeb, 0x97, 0x97, 0x2f, 0x2e, 0x2f, 0x16, 0x2e, 0x2c, 0x51, 0x45,
0x2a, 0x88, 0x24, 0x54, 0x20, 0x7b, 0xd5, 0xd7, 0xab, 0xaf, 0x2b, 0x97, 0x2f, 0x2e, 0x59, 0x65,
0x6e, 0x48, 0xa5, 0x72, 0x4f, 0xfa, 0xf4, 0xf5, 0xe9, 0xeb, 0xa9, 0xd7, 0xab, 0xaf, 0x5d, 0x75,
0xa8, 0x28, 0xa5, 0x41, 0x1f, 0xf2, 0x74, 0x74, 0xe8, 0xe9, 0xef, 0xe5, 0xe7, 0xcb, 0xce, 0x39,
0xa8, 0x28, 0xa5, 0x41, 0x18, 0x4, 0x34, 0x34, 0x68, 0x68, 0xe0, 0x8, 0xf0, 0x11, 0xe0, 0x82,
0xe6, 0xc6, 0xa5, 0x36, 0x7, 0xf8, 0x8, 0x8, 0x10, 0x10, 0x7f, 0xf0, 0x7f, 0xe0, 0xff, 0x7c
};


while(1)
    {
    donjon.init();
    if(!key_down(K_DOWN) && !key_down(K_UP) && !key_down(K_EXE)&& (!positionX || positionX== 50))checkTouche = 1;


    if(key_down(K_DOWN) && checkTouche){positionY++;checkTouche = 0;}
    if(key_down(K_UP) && checkTouche){positionY--;checkTouche = 0;}

    if(positionX == 50)
        {
        donjon.memoire(CHARGEMENT,positionY);
        }
    if(key_down(K_EXE) && checkTouche)
        {
        checkTouche = 0;
        if(positionX == 0)
            {
            if(positionY == 2)credit();
            else
                {
                choixContinuer = positionY;
                directionX=1;
                donjon.memoire(CHARGEMENT,positionY);
                }
            }
        else break;
        }

    if(key_down(K_ALPHA) && checkTouche)directionX=-1;
    
    if(key_down(K_MENU))reset_calc();

    if(positionY == -1)positionY = 2;
    if(positionY>2)positionY = 0;


    positionX+=directionX;
    if(positionX <0)positionX = 0;
    if(positionX >50)positionX = 50;

    String info(donjon.getSecondeJouee()/3600);
    if(frame&0x40)info+=":";
    else info+=" ";
    info+=(donjon.getSecondeJouee()/60)%60;
    info+="\n";
    info+=donjon.getPourcentQuete();
    info+=" %\nlvl ";
    info+=donjon.getNiveauHeros()+1;    

    ML_bmp_or(ecran_titre,0,5,128,19);
    choix1.afficherRetour(5,emplacementY);

    choix2.afficherRetour(55,emplacementY+25-positionX/2);
    info.afficherRetour(95,emplacementY+25-positionX/2);
    fleche.afficher(1+positionX,emplacementY+6*positionY);
    ML_display_vram();
    ML_clear_vram();
    setFps(2);
    frame++;
    }

return (choixContinuer<<4)+positionY;
}




int main()
{

//initialisation
while(1)
    {
    Options::setFont(0);
    initLog();
    random(- time_getTicks());
    initGetSprite("\000\001\002\003\004\005\006\007\010\011\012\013\014\015\016\017\018\019",16);
    Donjon donjon;


    int retour = menu();

    if(key_down(K_LOG) && key_down(K_1) && key_down(K_F6) && !key_down(K_F5) && !key_down(K_0) && !key_down(K_2) && !key_down(K_4)  || !REALEASE)
        {
        donjon.init();
        donjon.memoire(CHARGEMENT,retour&0xF);
        if((retour&0xF0) == 0)donjon.init();
        donjon.startGame();

        while(key_down(K_EXE));
        //boucle principale
        while(1)
            {

            if(donjon.startFrame())break;
            donjon.tour();

            donjon.refreshBrouillard();
            donjon.afficherMap();
            int FPS = getFps();
            String fps(FPS);
            fps+=" ";
            fps+=donjon.getSecondeJouee();
            //fps.afficher(107-Options::getLargeurFont()*3,0,1);
            ML_display_vram();
            ML_clear_vram();
            donjon.endFrame(FPS);
            setFps(Options::getFPS());

            }
        endLog();
        endSprite();
        }
    }
}



extern "C"
{
int AddIn_main(int isAppli, unsigned short OptionNum)
{
    return main();
}
#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
}
