 extern "C"
{
#include "fxlib.h"
#include "LibText.h"
#include "usefull.h"
#include "math.h"
}

#include "generateur.h"
#include "MonochromeLib.h"
#include "donjon.h"
#include "PNJ.h"
#include "ennemi.h"
#include "etreVivant.h"
#include "heros.h"
#include "string.h"
#include "donnees.h"


/************************************

Classe representant les ennemis

************************************/


void Ennemi::init(unsigned char* map,int tailleX,int tailleY,unsigned char etage)
{
EtreVivant::init();
int j;
do{
positionX = random(tailleX)*TAILLE_MAX;
positionY = random(tailleY)*TAILLE_MAX;
j = positionX/TAILLE_MAX+positionY*tailleX/TAILLE_MAX;
}
while((map[j]&MASQUE_N_VISION) != SALLE);

map[j] =(map[j]&MASQUE_N_ETRE_VIVANT) |MASQUE_ETRE_VIVANT;


direction = BAS;

int IDTemp = etage/3;
IDTemp += random(3)+random(3)-2;//donne de -2 a 2 avec 33% d'avoir 0, 2/9 d'avoir +- 1 et 1/9 d'avoir +-1
if(IDTemp<0)IDTemp = 0;
ID = IDTemp;
if(ID>=NOMBRE_MONSTRE)ID = NOMBRE_MONSTRE-1;

IDsprite = ID+1;


unsigned char temp[10];
loadCaraEnnemi(ID,temp);
for(int i = 0;i<7;i++)caracteristiques[i]=temp[i];
pv = caracteristiques[PV];
pm = caracteristiques[PM];
level = temp[9];

degatPhysiqueMin=temp[7];
degatPhysiqueMax=temp[8];
sortEnCours = 0;

vivant = 1;
}



void Ennemi::effetArme(EtreVivant* ennemi)
{
ennemi->subirDegat(random(degatPhysiqueMax-degatPhysiqueMin+1)+degatPhysiqueMin,PHYSIQUE,caracteristiques[FORCE]);
}



void Ennemi::memoire(Sauvegarde& sauvegarde)
{
EtreVivant::memoire(sauvegarde);
sauvegarde.addUChar(ID);
}
