#ifndef GRAPHISME_H
#define GRAPHISME_H

#define WINDOW_FULL 0
#define WINDOW_DIALOGUE 1
#define WINDOW_MENU 2
#define WINDOW_OUI_NON 3
#define WINDOW_ENCYCLOPEDIE_LISTE 4
#define WINDOW_INVENTAIRE_ICONE 5
#define WINDOW_INVENTAIRE_AUTRE 6
#define WINDOW_LITLLE_DIALOGUE 7
#define WINDOW_DESCRIPTION_SORT 8

void afficherDescriptionEtreVivant(unsigned char IDsprite,int X,int Y);

void afficherSprite(unsigned char* sprite,int X,int Y,unsigned char tailleSprite,unsigned char mode = 1);
void initGetSprite(unsigned char* lequels,int nombre);
void endSprite();
void afficherSpriteEtreVivant(unsigned char IDsprite,unsigned char direction,int positionX,int positionY,int X,int Y, int tailleSprite);
void afficherSpriteObjet(unsigned char IDsprite,int X,int Y, int tailleSprite);
void afficherSpriteMap(unsigned char IDsprite,int X,int Y,int tailleSprite);

void endTimer();
void launchTimer();
void afficherIcone(int endroit);

void fenetre(unsigned char which,int mode = 1);

void launchChargement(int mode);
void endChargement();
void launchSauvegarde();
void endSauvegarde(int reussite);
void chargement();
void afficherDialogue(char* dialogue,int longueur);

#endif
