 extern "C"
{
#include "fxlib.h"
#include "LibText.h"
#include "usefull.h"
#include "math.h"
}

#include "generateur.h"
#include "MonochromeLib.h"
#include "donjon.h"
#include "PNJ.h"
#include "ennemi.h"
#include "etreVivant.h"
#include "heros.h"
#include "string.h"
#include "graphisme.h"
#include "donnees.h"
#include "log.h"

/************************************

La classe pour les objet que l'on peut ramasser

************************************/


Objet::Objet()
{
    //ctor
}

void Objet::init(unsigned char* map,int tailleX,int tailleY,unsigned char etage)
{
Element::init();

int hasard = random(100);

if(hasard<50)ID = 0;

else if(hasard<65)ID = 1;
else if(hasard<80)ID = 4;

else if(hasard<87)ID = 2;
else if(hasard<94)ID = 5;

else if(hasard<97)ID = 3;
else ID = 6;

int j;
do
    {
    positionX = random(tailleX)*TAILLE_MAX;
    positionY = random(tailleY)*TAILLE_MAX;
    j = positionX/TAILLE_MAX+positionY*tailleX/TAILLE_MAX;
    }
while((map[j]&MASQUE_N_VISION) != SALLE);
}

void Objet::afficher(int fenetreX,int fenetreY,int cameraX,int cameraY,unsigned char tailleSprite)
{
int spriteX = (positionX-cameraX)/(TAILLE_MAX/tailleSprite)+fenetreX;
int spriteY =(positionY-cameraY)/(TAILLE_MAX/tailleSprite)+fenetreY;

afficherSpriteObjet(ID,spriteX,spriteY,tailleSprite);
}


int Objet::getID()
{
return ID;
}


int Objet::ramasser()
{
positionX = -1;
positionY = -1;
log("vous ramassez un objet",LOG_INFO);
return ID;
}


void Objet::memoire(Sauvegarde& sauvegarde)
{
Element::memoire(sauvegarde);
sauvegarde.addUChar(ID);
}

