#include "sauvegarde.h"
extern "C"
{
#include "usefull.h"
#include "fxlib.h"
}
Sauvegarde::Sauvegarde(int modeT,int tailleMax,unsigned char* fichierT,unsigned char* extensionT)
{
for(int i = 0;fichierT[i];i++)fichier[i] = fichierT[i];
for(int i = 0;extensionT[i];i++)extension[i] = extensionT[i];
stockage = new unsigned char[tailleMax];
for(int i = 0;i<tailleMax;i++)stockage[i]=0;
position = 0;
mode = modeT;
erreur = 0;
if(mode == CHARGEMENT)if(!readFile(fichier,extension,stockage))erreur = 1;
}


void Sauvegarde::addInt(int& argument)
{
if(erreur)return;
unsigned char temp =4;
addTab((unsigned char*)&argument,temp);

}

void Sauvegarde::addUChar(unsigned char& argument)
{
if(erreur)return;
unsigned char temp =1;
addTab(&argument,temp);
}

void Sauvegarde::addTab(unsigned char* argument,unsigned char& taille)
{
if(erreur)return;
if(mode == SAUVEGARDE)
    {
    stockage[position] = taille;
    position++;
    for(int i = 0;i<=taille;i++,position++)stockage[position] = argument[i];

    }
else
    {
    taille = stockage[position];
    position++;
    for(int i = 0;i<taille;i++,position++)argument[i]=stockage[position];
    position++;
    }
}

int Sauvegarde::end()
{
int retour = 1;
if(mode == SAUVEGARDE)retour = writeFile(fichier,extension,stockage,position);

delete[] stockage;
return retour;
}


